Library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

Entity AC is
	port(input:in std_logic_vector(7 downto 0);
	     clr, clk, inr, com, shl, shr, load, read:in std_logic;
	     output:out std_logic_vector(7 downto 0));
End AC;

Architecture AC_arch of AC is
	Signal input_signal, output_signal, mem_contents:std_logic_vector(7 downto 0);
	
	begin
		input_signal <= input;
		output <= output_signal;
		
		clkpulse:process(clk, inr, load, clr, com, shl, shr, read)
		begin
			if(clk'event and clk ='1') then	--Positive edge triggered
				if(load = '1') then	
					mem_contents <= input_signal; --Load from bus
					
				elsif (inr ='1') then
					mem_contents <= (mem_contents + 1);
					
				elsif(clr = '1') then
					mem_contents <= "00000000";
				
				elsif(com = '1') then
					mem_contents <= (not mem_contents);
				
				elsif(shl = '1') then
					mem_contents <= (mem_contents(6 downto 0) & '0');
				
				elsif(shr = '1') then 
					mem_contents <= ('0' & mem_contents(7 downto 1));
				
				elsif(read = '1') then
					output_signal <= mem_contents;

				end if;
			end if;
			
			
		end process;
		
		
end AC_arch;
				
	
